﻿Imports C1.Win.C1TrueDBGrid

Public Class Form1

    Dim dv As DataView = New DataView()

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'C1NWINDDataSet.Employees' table. You can move, or remove it, as needed.
        Me.EmployeesTableAdapter.Fill(Me.C1NWINDDataSet.Employees)
        'TODO: This line of code loads data into the 'C1NWINDDataSet.Employees' table. You can move, or remove it, as needed.
        Me.EmployeesTableAdapter.Fill(Me.C1NWINDDataSet.Employees)

        dv.Table = C1NWINDDataSet.Employees
        Me.C1TrueDBGrid1.DataSource = dv

        C1TrueDBGrid1.FilterBar = True
        C1TrueDBGrid1.AllowFilter = False

        Dim col As C1DataColumn
        For Each col In C1TrueDBGrid1.Columns
            col.FilterDropdown = True
            col.FilterMultiSelect = True
            col.FilterSeparator = ";"
        Next

    End Sub
    Dim flag As Integer = 0

    Private Sub C1TrueDBGrid1_FilterChange(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles C1TrueDBGrid1.FilterChange
        Dim int_col As Integer = 0
        Dim str As String = Nothing
        'build our filter expression
        Dim sb As New System.Text.StringBuilder()
        Dim multi As Integer = 0
        Dim dc As C1.Win.C1TrueDBGrid.C1DataColumn
        For Each dc In Me.C1TrueDBGrid1.Columns
            If dc.FilterText.Length > 0 Then
                If sb.Length > 0 Then
                    sb.Append(" AND ")
                End If
                If flag = 1 Then
                    If dc.FilterText.Contains(dc.FilterSeparator) Then
                        Dim words() As String = dc.FilterText.ToString().Split(dc.FilterSeparator)
                        For Each word As String In words
                            sb.Append((dc.DataField + " = " + "'" + word + "'"))
                            sb.Append(" OR ")
                        Next
                        multi = 1

                    Else
                        'using '=' in case of filter dropdown
                        sb.Append((dc.DataField + " = " + "'" + dc.FilterText + "'"))
                    End If

                Else
                    If dc.DataType.Name = "Int32" Then
                        int_col = 1
                        'using 'IN' in case of filter text entered in filterbar is Integer & multiple selections are there
                        Dim words() As String = dc.FilterText.ToString().Split(dc.FilterSeparator)
                        sb.Append(dc.DataField + " IN " + "(")
                        For Each word As String In words
                            If word <> Nothing Then
                                sb.Append(word + ",")
                            End If
                        Next
                        str = sb.ToString().Remove(sb.ToString().Length - 1)
                        str += ")"
                    Else
                        If dc.FilterText.Contains(dc.FilterSeparator) Then
                            Dim words() As String = dc.FilterText.ToString().Split(dc.FilterSeparator)
                            For Each word As String In words
                                sb.Append((dc.DataField + " = " + "'" + word + "'"))
                                sb.Append(" OR ")
                            Next
                            multi = 1
                        Else
                            'using 'like' in case of filter text entered in filterbar
                            sb.Append((dc.DataField + " like " + "'" + dc.FilterText + "*'"))
                        End If
                    End If
                End If
            End If
        Next dc

        If multi = 1 Then         ' if multiple selections are there in the dropdown or in the FilterBar
            ' filter the data
            dv.RowFilter = sb.ToString().Remove(sb.Length - 3).ToString()  'removing the last appended OR from sb
        Else
            If int_col = 1 Then      ' if integer column with multiple options in filterbar
                'filter the data using str
                dv.RowFilter = str
            Else
                'filter the data using sb in integer column with a single option
                dv.RowFilter = sb.ToString()
            End If
         End If


        'after filtering, set the value of flag again to default
        flag = 0
    End Sub

    Private Sub C1TrueDBGrid1_FilterButtonClick(ByVal sender As System.Object, ByVal e As C1.Win.C1TrueDBGrid.ColEventArgs) Handles C1TrueDBGrid1.FilterButtonClick
        'if the filter button is clicked i.e., filtering the column through the filter dropdown 
        flag = 1
    End Sub

End Class
